# Pharmathen layouts update

> 22th of May 2024

Upgrade: add support for three-line layout.

## Issues

This is not a standard upgrade as we don't have a VPN access to the machine and are therefore unable to run Ansible scripts to perform the upgrade. We will get a remote session with the clients PC via AnyDesk. There are multiple possible options on how to proceed:

- Install WSL and Ansible on their machine. Copy all of our Ansible scripts and run the scripts from there (a lot of work and might not work)
- SSH into the machine and try to use NGROK to get direct connection to machine (might be against company policy)
- **SSH into the machine and perform the upgrade manually.**

## Procedure

We decided to go with the last option as it would be by far the quickest and easiest way to perform the upgrade (choosing from the ones that do not include having a "backdoor" or a VPN to the machine).

- Use Putty (already installed on their machine) to SSH into our printer. Use service SSH key to connect to the printer.
- Copy update config files:
  - `calibration.toml` (llamajet controller)
  - `config.toml` (llamajet controller)
  - `exposed-api-lek.toml` (exposed API Lek config)
  - `vial-service-config.toml` (vial service)
  - `layouts.toml` (configurator)
  - `trays.toml` (configurator)
  - `configurator_config.toml` (configurator)
- Copy `download_artifact.py` and use it to download the latest version of the `llamajet-controller`. Copy binary file to the correct location and restart the service.
- Login to docker (create a new key and disable it after the upgrade) and update `docker-compose.yml` to the correct version of `llamajet-vial-service` and `llamajet-configurator` and restart the service.
- Use `download_artifact.py` to download new version of `llamajet-web`. Extract the files and copy them to the correct location (see playbook for the correct location). Restart the Nginx service.
- Download new version of `llamajet-flutter`. Copy the file to the correct location. Reboot the machine and instruct the client to visually check if the app is working correctly.
- Create new job in web interface and check if the new layout is available.
- Create new print job with the new layout and instruct the client to check if the print is correct.
